/*
 * Created on Dec 19, 2003
 * 
 */
package eclipse.kickstart.example;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.StringTokenizer;
import java.util.Vector;

/**
 * @author carlos
 * 
 */
public class CalculatorInput {

    private BufferedReader _in;

    private SimpleCalculator _calculator;

    public CalculatorInput() {
        InputStreamReader reader = new InputStreamReader(System.in);
        _in = new BufferedReader(reader);

        _calculator = new SimpleCalculator();
    }

    public static void main(String[] args) {
        CalculatorInput app = new CalculatorInput();
        try {
            app.start();
        } catch (IOException e) {
            System.out.println("Exception found: " + e.getMessage());
        }
    }

    /**
     *  
     */
    public void start() throws IOException {
        String calcStr = null;

        System.out.println(
                "Enter a space-separated list of numbers to add (q to exit):");
        calcStr = _in.readLine();
        int[] value = null;
        int result;
        while (calcStr.equals("q") == false) {
            result = 0;
            value = parseValues(calcStr);
            for (int i = 0; i < value.length; i++) {
                result = _calculator.add(value[i], result);
            }

            System.out.println("Result: " + result);
            calcStr = _in.readLine();
        }
    }

    /**
     * @param calcStr
     * @return
     */
    private int[] parseValues(String calcStr) {
        int[] result = null;

        Vector v = new Vector();
        StringTokenizer tokenizer = new StringTokenizer(calcStr);
        while (tokenizer.hasMoreTokens()) {
            String strVal = (String) tokenizer.nextToken();
            v.add(strVal);
        }

        result = new int[v.size()];
        for (int i = 0; i < result.length; i++) {
            result[i] = Integer.parseInt((String) v.get(i));
        }
        return result;
    }
}