package extract;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Vector;

import javax.sql.DataSource;

public class OrderFactory {
    // This would be retrieved from a JNDI source
    private DataSource _dataSource;

    public Order[] findLessThan(int maxTotal) throws SQLException {
        Order[] result = null;

        Connection con = null;
        Statement stmt = null;
        String query = "select id, customer_id, total from order";
        try {
            con = _dataSource.getConnection();
            stmt = con.createStatement();
            ResultSet rs = stmt.executeQuery(query);
            result = createOrdersFrom(rs, maxTotal);

        } finally {
            closeDataSource(con, stmt);
        }

        return result;
    }

    /**
     * @param con
     * @param stmt
     * @throws SQLException
     */
    private void closeDataSource(Connection con, Statement stmt) throws SQLException {
        if (stmt != null) {
            stmt.close();
        }
        if (con != null) {
            con.close();
        }
    }

    /**
     * @param rs
     * @param maxTotal
     * @return
     * @throws SQLException
     */
    private Order[] createOrdersFrom(ResultSet rs, int maxTotal) throws SQLException {
        Order[] result;
        Vector v = new Vector();
        while (rs.next()) {
            int total = rs.getInt("total");
        
            if (total <= maxTotal) {
                int orderId = rs.getInt("id");
                int customerId = rs.getInt("customer_id");
                v.add(new Order(orderId, customerId, total));
            }
        }
        
        result = new Order[v.size()];
        v.copyInto(result);
        return result;
    }
}
